IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_GDPRApprove') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_GDPRApprove 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_GDPRApprove]
ON [dbo].[GDPRApprove] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'GDPRApprove',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([Name])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'Name',
			CONVERT(nvarchar(4000), OLD.[Name], 0),
			CONVERT(nvarchar(4000), NEW.[Name], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[Name] <>
					OLD.[Name]
				) Or
			
				(
					NEW.[Name] Is Null And
					OLD.[Name] Is Not Null
				) Or
				(
					NEW.[Name] Is Not Null And
					OLD.[Name] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([DescriptionShort])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'DescriptionShort',
			CONVERT(nvarchar(4000), OLD.[DescriptionShort], 0),
			CONVERT(nvarchar(4000), NEW.[DescriptionShort], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[DescriptionShort] <>
					OLD.[DescriptionShort]
				) Or
			
				(
					NEW.[DescriptionShort] Is Null And
					OLD.[DescriptionShort] Is Not Null
				) Or
				(
					NEW.[DescriptionShort] Is Not Null And
					OLD.[DescriptionShort] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Description])
	BEGIN
    
	  	INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
            NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT TOP 1
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(ORD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'Description',
			ORD.[Description],
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), ORD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
		FROM inserted NEW INNER JOIN [dbo].[GDPRApprove] ORD WITH (NOLOCK) 
            ON (CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), ORD.[Id], 0) or (NEW.[Id] Is Null and ORD.[Id] Is Null))
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([GDPRApprovalType])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'GDPRApprovalType',
			CONVERT(nvarchar(4000), OLD.[GDPRApprovalType], 0),
			CONVERT(nvarchar(4000), NEW.[GDPRApprovalType], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[GDPRApprovalType] <>
					OLD.[GDPRApprovalType]
				) Or
			
				(
					NEW.[GDPRApprovalType] Is Null And
					OLD.[GDPRApprovalType] Is Not Null
				) Or
				(
					NEW.[GDPRApprovalType] Is Not Null And
					OLD.[GDPRApprovalType] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Enable])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'Enable',
			CONVERT(nvarchar(4000), OLD.[Enable], 0),
			CONVERT(nvarchar(4000), NEW.[Enable], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[Enable] <>
					OLD.[Enable]
				) Or
			
				(
					NEW.[Enable] Is Null And
					OLD.[Enable] Is Not Null
				) Or
				(
					NEW.[Enable] Is Not Null And
					OLD.[Enable] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([IncludedInCommonTerms])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'IncludedInCommonTerms',
			CONVERT(nvarchar(4000), OLD.[IncludedInCommonTerms], 0),
			CONVERT(nvarchar(4000), NEW.[IncludedInCommonTerms], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[IncludedInCommonTerms] <>
					OLD.[IncludedInCommonTerms]
				) Or
			
				(
					NEW.[IncludedInCommonTerms] Is Null And
					OLD.[IncludedInCommonTerms] Is Not Null
				) Or
				(
					NEW.[IncludedInCommonTerms] Is Not Null And
					OLD.[IncludedInCommonTerms] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([EnableForSendDataCheck])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[Id]='+CONVERT(nvarchar(4000), IsNull(OLD.[Id], NEW.[Id]), 0), '[Id] Is Null')),
		    'EnableForSendDataCheck',
			CONVERT(nvarchar(4000), OLD.[EnableForSendDataCheck], 0),
			CONVERT(nvarchar(4000), NEW.[EnableForSendDataCheck], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Id], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Id], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[Id], 0)=CONVERT(nvarchar(4000), OLD.[Id], 0) or (NEW.[Id] Is Null and OLD.[Id] Is Null))
			where (
			
			
				(
					NEW.[EnableForSendDataCheck] <>
					OLD.[EnableForSendDataCheck]
				) Or
			
				(
					NEW.[EnableForSendDataCheck] Is Null And
					OLD.[EnableForSendDataCheck] Is Not Null
				) Or
				(
					NEW.[EnableForSendDataCheck] Is Not Null And
					OLD.[EnableForSendDataCheck] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
